/*
 * Vol.c
 *
 * Created: 2013/11/03 8:16:52
 *  Author: Jyaku9
 */ 

#ifndef F_CPU
#define F_CPU 300000UL	// 0.3[MHz] (9.6[MHz]  32 )
#endif

#include <avr/io.h>
#include <avr/sfr_defs.h>
#include <util/delay.h>

// ADCω
#define _ADC_COUNT	32
// ͂ωƔf邵l
// (5[V] / 256 19.5[mV]  1 ̓d)
#define _ADC_TH		2
// ADC ̍ŏlimCY悯j
#define _ADC_MIN	5
// ADC ̍őlimCY悯j
#define _ADC_MAX	250

// j^LED ̍Œli0 ` 127 ̒l + ADC  /2 o͂j
#define _MON_LED_OFFSET		20

// dq{[ SIO ʐM̃NbNfBC
// tHgJv͂܂葁Ȃ̂ŗ~肷Ȃ
#define _SIO_CLOCK_DELAY()	_delay_us(10)
//#define _SIO_CLOCK_DELAY()	_delay_ms(1)
// dq{[̃`bvZNg̃|[g
#define _CS_ON()	PORTB |= _BV(PB3)
#define _CS_OFF()	PORTB &= ~_BV(PB3)
// dq{[̃NbÑ|[g
#define _CLK_ON()	PORTB |= _BV(PB1)
#define _CLK_OFF()	PORTB &= ~_BV(PB1)
// dq{[̃f[^̃|[g
#define _DATA_ON()	PORTB |= _BV(PB4)
#define _DATA_OFF()	PORTB &= ~_BV(PB4)


int main(void)
{
	// OADϊ̒l
	int16_t ACD_prev_val = - _ADC_TH;
	// OADϊlƂ̍
	int16_t ADC_diff = 0;
	// ADϊ
	int16_t ADC_val = 0;
	
	// j^LED  PWM ݒl
	uint8_t mon_led_val = 0;
	
	/////////////////////////////////////
	// sAADC ̏
	init();
	
	/////////////////////////////////////
	// C[v
	while(1)
	{
		// ADϊĕς
		int16_t sum = 0;
		
		for(int8_t i = 0 ; i < _ADC_COUNT ; i ++)
		{
			// ADC Jn
			ADCSRA |= _BV(ADIF);
			ADCSRA |= _BV(ADSC);
			
			// ϊI҂
			loop_until_bit_is_set(ADCSRA, ADIF);
						
			// ϊIŉZ
			sum += (int)ADCH;
		}
		
		ADC_val = sum / _ADC_COUNT;
		
		if(ADC_val <= _ADC_MIN)
			ADC_val = 0;
		else if(ADC_val >= _ADC_MAX)
			ADC_val = _ADC_MAX;
		
		// OƂ̍vZ
		ADC_diff = ACD_prev_val - ADC_val;
		
		if(ADC_diff < 0)
			ADC_diff *= -1;
		
		// OƂ̍l𒴂{[ύX
		if(ADC_diff >= _ADC_TH)
		{
			// j^[LED  PWM ݒ
			mon_led_val = _MON_LED_OFFSET + (uint8_t)ADC_val / 2;
			OCR0A = mon_led_val;
			
			// {[ύX
			change_volume((uint8_t)ADC_val);

			// O̒lXV
			ACD_prev_val = ADC_val;
		}		
    }
}

/* *********************************************
 * {[ύX
 * 0 ` 255 Őݒ
 * ****************************************** */
void change_volume(uint8_t vol)
{
	__change_volume_ch(0, vol);
	__change_volume_ch(1, vol);
}

void __change_volume_ch(uint8_t ch, uint8_t vol)
{
	int8_t set_vol = 0x7f - (vol / 2);
	int8_t i = 0;
	
	_CLK_OFF();
	_DATA_OFF();
	_SIO_CLOCK_DELAY();
	
	_CS_OFF();
	_SIO_CLOCK_DELAY();
	
	// ch  MSB o
	for(i = 7 ; i >= 0 ; i --)
	{
		if((ch >> i) & 1)
			_DATA_ON();
		else
			_DATA_OFF();
		
		_SIO_CLOCK_DELAY();
		
		_CLK_ON();
		_SIO_CLOCK_DELAY();
		_CLK_OFF();
	}
	
	// Data  MSB o
	for(i = 7 ; i >= 0 ; i --)
	{
		if((set_vol >> i) & 1)
			_DATA_ON();
		else
			_DATA_OFF();
		
		_SIO_CLOCK_DELAY();
		
		_CLK_ON();
		_SIO_CLOCK_DELAY();
		_CLK_OFF();
	}
	
	_SIO_CLOCK_DELAY();
	_CS_ON();
	
	_SIO_CLOCK_DELAY();
	_CLK_ON();
	_DATA_ON();
}

/* *********************************************
 * 
 * ****************************************** */
void init()
{
	////////////////////////////////////////////////
	// NbNݒ
	
	// OuWX^(32 )
	// 9.6[MHz] / 32 = 300[kHz] mCY̌̂őKv͖
	//			76543210
	CLKPR	= 0b10000000;
	CLKPR	= 0b00000101;
	
	////////////////////////////////////////////////
	// s̐ݒ
	
	// PB0 : out LED (PWM)
	// PB1 : out dq{[ SCL
	// PB2 : in vAbvȂ  ADC CH1 Ń{[̒lǂݎ̂Ɏgp܂
	// PB3 : out dq{[ CS
	// PB4 : out dq{[ Data
	// PB5 : in ̃s̓ZbgȂ̂Ŏgp܂
	
	DDRB = _BV(DDB0) | _BV(DDB1) | _BV(DDB3) | _BV(DDB4);
	PORTB = _BV(PB2);
	
	asm("nop");
	
	_CS_ON();
	_CLK_ON();
	_DATA_ON();
	_SIO_CLOCK_DELAY();
	
	////////////////////////////////////////////////
	// PWM ̐ݒ
	
	//  PWM [h  PB0 gp
	//			76543210
	TCCR0A	= 0b11000011;	// rv ]
	TCCR0B	= 0b00000001;
	
	// OCR0A
	
	////////////////////////////////////////////////
	// ADC ̐ݒ
	
	//			76543210
	ADMUX   = 0b00100001;
	// ޯ6 - REFS0 : dI	(0  VCCA1  d 1.1V)
	// ޯ5 - ADLAR : I
	// ޯ3`0 - MUX3`0 : A/DّI
	
	//			76543210
	ADCSRA	= 0b10000010;
	// ޯ7 - ADEN : A/D
	// ޯ6 - ADSC : A/DϊJn
	// ޯ5 - ADATE : A/DϊN 0 : Ȃ(̓^C}[)
	// ޯ4 - ADIF : A/Dϊ荞ݗv׸ <- ŕϊI`FbN!
	// ޯ3 - ADIE : ADϊ
	// ޯ2`0 - ADPS2`0 : A/DϊۯI
	
	// ADCNbN 4 ɐݒi300[kHz] / 4 = 75[kHz] j
	//  25NbNi0.333[ms]jAʏ 13 NbN(0.173[ms])ŕϊ
	
	//		   76543210
	ADCSRB = 0b00000000;
	
	// ޼ٓ͋֎~ڼ޽
	DIDR0 = _BV(ADC1D);
	
	// ADCH ɏ 8bit 
	
	asm("nop");
}